//==============================================================
// Simple IME Ver0.70   (STPP.04)
//     for PSP CFW3.80 M33-5
// STEAR 2009
//--------------------------------------------------------------
// PSPp̊ȈIME쐬Ă݂eXgB
// \tgEFAL[{[hƏnꊿϊB
//--------------------------------------------------------------

#include <pspuser.h>
#include <pspctrl.h>
#include <pspgu.h>
#include <pspdisplay.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>

#include "zenkaku.h"
#include "draw.h"
#include "sime.h"

//----- }N -----


//----- 萔ݒ -----

#define DICFILE1	"SIME.DIC"					// t@C
#define DICFILE2	"ms0:/PSP/COMMON/SIME.DIC"

#define KBPOSX		260							// \tgEFAL[̈ʒuX
#define KBPOSY		105							// \tgEFAL[̈ʒuY
#define KEYREP1		12							// L[s[gJn܂ł̎
#define KEYREP2		2							// L[s[g̊Ԋu
#define FONTX		6							// tHg̒
#define FONTY		12							// tHg̍
#define CHLEN		32							// ϊC̍ő啶
#define KLIST		6							// ⃊Xg̍s

#define CORFL1		0xC0A0A0					// g
#define CORFL2		0xFFE0E0					// 邢g
#define CORFL3		0x806080					// Âg
#define CORIN		0x600060					// EBhEwi
#define CORCUR		0xFF8080					// J[\
#define CORRBAR		0x70E070					// XN[o[
#define CORWCHR		0xFFFFFF					// EBhE
#define CORSCHR		0xB0FFB0					// EBhEꕶ
#define CORFCHR		0x000000					// EBhEg
#define CORCHBK		0xFFFFFF					// ϊCwi
#define CORCHCR		0x000000					// ϊC
#define CORCHCU		0xFF8080					// ϊCÏ

//----- vg^Cv錾 -----

static int	DicLoad(char *DicFile);

//------ O[oϐ -----

static char			gKeyTable[6][161] = {
						"ĂƂȂ͂Ђɂӂւʂق܂˂݂ނ̂߂₟J䂣K悧AB[uOPivQRjISTHhUV`EWX@",
						"AJL^CNP`ERTcGVXeIZ\\ginqjtwkz}l~m@BJDFKHABb[uOPivQRjISTHhUV`EWX@",	// u\\vӁI
						"`abcdefghijklmnopqrstuvwxy|fCDIH",
						"hOPfQRiSTjUVfWX{|}~C^_DFGIHmnOQopb`Ec~",
						"A B C D E F G H I J K L M N O P Q R S T U V W X Y Z a b c d e f g h i j k l m n o p q r s t u v w x y z - ' , . ! ? ",
						"0 1 2 3 4 5 6 7 8 9 ! \" # $ % & ' ( ) * + , - . / : ; < = > ? @ [ \\ ] ^ _ ' { | } ~ "
					};
static char			gKeyName[6][25] = {
						"PFSp Ђ炪",
						"QFSp J^Ji",
						"RFSp At@xbg",
						"SFSp ƋL",
						"TFp At@xbg",
						"UFp ƋL"
					};
static long			gHEDtbl[85],gDicWordPos,gDicSize;
static long			gBackBuf[(194+24)*(166) +2],							// \tgL[wiҔobt@
					gInLnBuf[480*FONTY +2],									// ϊCwiҔobt@
					gkListBuf[(CHLEN*FONTX+6+4+2) * ((FONTY+1)*KLIST + 2)];	// ⃊XgwiҔobt@
static char			*gDic,gDicFile[32],gSt[CHLEN +1];
static int			gKx,gKy,gKt,gKfa,gMode,gBDFlag,gSaveFlag;
static int			*gCx,*gCy;


//==============================================================
// t@C̓ǂݍ
//--------------------------------------------------------------
// ߂lF0 ̓ǂݍݐ
//         1 sȎt@C
//         2 Ȃ
//         3 t@CJȂi݂ȂHj
//--------------------------------------------------------------

static int DicLoad(char *DicFile)
{
	int		i,fa;
	long	pos,filesize;
	FILE*	fp1;

	fa = 0;
	fp1 = fopen( DicFile, "rb" );
	if (fp1!=NULL){
		fseek( fp1, 0L, SEEK_END );
		filesize = ftell( fp1 );
		fseek( fp1, 0L, SEEK_SET );
		pos = fread( gHEDtbl, 4, 85, fp1 );
		if (pos!=85){
			fa = 1;								// Wve[uȂ
		} else {
			pos *= 4;							// Wve[uTCY
			for (i=0; i<85 ;i++){
				if (gHEDtbl[i]!=0xFFFFFFFF && (gHEDtbl[i]>filesize-pos))
					fa = 1;						// Wv悪f[^OĂ
			}
			if (!fa){
				gDic = (char*) malloc( filesize - pos );
				if (gDic==NULL){
					fa = 2;						// mۂłȂ
				} else {
					gDicSize = filesize - pos;
					fread( gDic, 1, gDicSize, fp1 );
				}
			}
		}
	} else {
		fa = 3;
	}
	fclose(fp1);

	if (fa)										// t@CJȂ
		for (i=0; i<85 ;i++)
			gHEDtbl[i] = 0xFFFFFFFF;

	return fa;
}


//==============================================================
// t@C̓ǂݍ݂Ɗe평
//--------------------------------------------------------------
// flag    0 EBhEɔwi𕜌
//      ȊO EBhEɉȂiCō悷ׂj
// x,y       J[\ʒuւ̃|C^
// ߂lF0 ̓ǂݍݐ
//         1 sȎt@C
//         2 Ȃ
//         3 t@CJȂi݂ȂHj
//--------------------------------------------------------------

int InitSIME(int flag,int *x,int *y)
{
	int ret;

	gKx = gKy = gKt = gKfa = gMode = 0;
	gCx = x;
	gCy = y;
	gDicWordPos = -1;
	gDicSize = 0;
	gSaveFlag = 0;
	if (flag){
		gBDFlag = 1;							// EBhEɉȂ
	} else {
		gBDFlag = 0;							// EBhEɔwi𕜌
	}

	ret = DicLoad( DICFILE1 );
	strcpy( gDicFile ,DICFILE1 );
	if (ret){
		ret = DicLoad( DICFILE2 );				// COMMONtH_
		strcpy( gDicFile ,DICFILE2 );
	}
	return ret;
}


//==============================================================
// t@C֏
//--------------------------------------------------------------
// ̕בւʂɏ
//--------------------------------------------------------------

static void DicSave(void)
{
	FILE*	fp1;

	if (gSaveFlag && gDicSize){
		fp1 = fopen( gDicFile, "wb+" );
		if (fp1!=NULL){
			fwrite( gHEDtbl, 4, 85, fp1 );
			fwrite( gDic, 1, gDicSize, fp1 );
			fclose(fp1);
		}
	}
}


//==============================================================
// I
//--------------------------------------------------------------
// ɕێĂt@Cɏ߂AJB
// sɓd؂铙Ɗ̕בւɔf܂B
//--------------------------------------------------------------

void EndSIME(void)
{
	DicSave();
	free(gDic);
}


//==============================================================
// L[
//--------------------------------------------------------------
// ߂l 0:͂Ȃ
//        :0x1C :0x1D :0x1E :0x1F
//        :0x0Di[Enter]j ~:0x1Bi[Esc]j :0x08i[BS]j :0x02 L:0x03 R:0x04
//        [START]:0x05 [SELECT]:0x06
//--------------------------------------------------------------
// e{^̏ԂL[{[hȃL[s[gŎ擾B
// ̏ꍇ͍Ōɉ{^ɑΉR[hԂB
//--------------------------------------------------------------

int Sgetchar(void)
{
	static SceCtrlData	pad1,pad2;
	static int			rep = 0,kcode,button;

	sceCtrlReadBufferPositive( &pad1, 1 );
	if ((pad1.Buttons & PSP_CTRL_UP) && !(pad2.Buttons & PSP_CTRL_UP)){			// uԂo
		rep = 0;																// s[gJE^Zbg
		kcode = 0x1E;															// o̓R[h
		button = PSP_CTRL_UP;													// s[gĎ{^
	}
	if ((pad1.Buttons & PSP_CTRL_DOWN) && !(pad2.Buttons & PSP_CTRL_DOWN)){
		rep = 0;
		kcode = 0x1F;
		button = PSP_CTRL_DOWN;
	}
	if ((pad1.Buttons & PSP_CTRL_LEFT) && !(pad2.Buttons & PSP_CTRL_LEFT)){
		rep = 0;
		kcode = 0x1D;
		button = PSP_CTRL_LEFT;
	}
	if ((pad1.Buttons & PSP_CTRL_RIGHT) && !(pad2.Buttons & PSP_CTRL_RIGHT)){
		rep = 0;
		kcode = 0x1C;
		button = PSP_CTRL_RIGHT;
	}
	if ((pad1.Buttons & PSP_CTRL_TRIANGLE) && !(pad2.Buttons & PSP_CTRL_TRIANGLE)){
		rep = 0;
		kcode = 0x02;
		button = PSP_CTRL_TRIANGLE;
	}
	if ((pad1.Buttons & PSP_CTRL_CROSS) && !(pad2.Buttons & PSP_CTRL_CROSS)){
		rep = 0;
		kcode = 0x1B;
		button = PSP_CTRL_CROSS;
	}
	if ((pad1.Buttons & PSP_CTRL_SQUARE) && !(pad2.Buttons & PSP_CTRL_SQUARE)){
		rep = 0;
		kcode = 0x08;
		button = PSP_CTRL_SQUARE;
	}
	if ((pad1.Buttons & PSP_CTRL_CIRCLE) && !(pad2.Buttons & PSP_CTRL_CIRCLE)){
		rep = 0;
		kcode = 0x0D;
		button = PSP_CTRL_CIRCLE;
	}
	if ((pad1.Buttons & PSP_CTRL_LTRIGGER) && !(pad2.Buttons & PSP_CTRL_LTRIGGER)){
		rep = 0;
		kcode = 0x03;
		button = PSP_CTRL_LTRIGGER;
	}
	if ((pad1.Buttons & PSP_CTRL_RTRIGGER) && !(pad2.Buttons & PSP_CTRL_RTRIGGER)){
		rep = 0;
		kcode = 0x04;
		button = PSP_CTRL_RTRIGGER;
	}
	if ((pad1.Buttons & PSP_CTRL_START) && !(pad2.Buttons & PSP_CTRL_START)){
		rep = 0;
		kcode = 0x05;
		button = PSP_CTRL_START;
	}
	if ((pad1.Buttons & PSP_CTRL_SELECT) && !(pad2.Buttons & PSP_CTRL_SELECT)){
		rep = 0;
		kcode = 0x06;
		button = PSP_CTRL_SELECT;
	}

	pad2 = pad1;

	if (pad1.Buttons & button){
		rep++;
		if (rep>KEYREP1) rep -= KEYREP2;					// L[s[g
		if (rep==1 || rep==KEYREP1) return kcode;			// Ă
	} else {
		rep = 0;
		kcode = 0;
		button = 0;
	}

	return 0;												// ĂȂ
}


//==============================================================
// \tgEFAL[{[h̕\
//--------------------------------------------------------------
// XY̒l}CiXɐݒ肷ƃJ[\͍悵ȂB
//--------------------------------------------------------------

static void DrawKey(int x,int y,int t)
{
	char key[3] = "  ";
	int i,j,k,s;
	int map[4][2] = {{1,0} , {0,1} , {2,1} , {1,2} };

	BoxFill( KBPOSX, KBPOSY, 193 +24, 15, CORFL1, CORFL1 );
	HLine( KBPOSX +2         , KBPOSY +2   ,193 +20,CORFL3 );					// 
	VLine( KBPOSX +2         , KBPOSY +2   ,14     ,CORFL3 );					// 
	HLine( KBPOSX +2         , KBPOSY +14  ,193 +20,CORFL2 );					// 
	VLine( KBPOSX +2 +193 +20, KBPOSY +2   ,14     ,CORFL2 );					// E
	mh_print( KBPOSX +4, KBPOSY +2, gKeyName[t], CORFCHR );						// 
	HLine( KBPOSX         , KBPOSY      ,194 +24,CORFL2 );						// 
	VLine( KBPOSX         , KBPOSY      ,164    ,CORFL2 );						// 
	HLine( KBPOSX         , KBPOSY +164 ,194 +24,CORFL3 );						// 
	VLine( KBPOSX +193 +24, KBPOSY      ,164    ,CORFL3 );						// E
	BoxFill( KBPOSX +1, KBPOSY +1+14, 192 +24, 149, CORFL1, CORIN );			// 
	for (i=0; i<4 ;i++)															// r
		HLine( KBPOSX +1       , KBPOSY +1 + i*37+14, 192 +24, CORFL1 );
	for (i=0; i<5 ;i++)
		VLine( KBPOSX +1 + i*43, KBPOSY +1       +14, 149    , CORFL1 );
	if (x>=0 && y>=0)															// L[{[hJ[\
		BoxFill( KBPOSX +1 + x*43, KBPOSY +1 + y*37+14, 44, 38, CORFL1, CORCUR );

	if (t>3){																	// p̈ʒu␳
		s = 3;
	}else{
		s = 0;
	}

	for (i=0; i<4 ;i++)															// \tgEFAL[{[h
		for (j=0; j<5 ;j++)
			for (k=0; k<4 ;k++){
				key[0] = gKeyTable[t][(i*20+j*4+k)*2];
				key[1] = gKeyTable[t][(i*20+j*4+k)*2+1];						// L[}bvꕶo
				mh_print( KBPOSX +1 + j*43 + map[k][0]*12+4 +s, KBPOSY +1 + i*37 + map[k][1]*11+2 +14, key, CORWCHR );
			}
	if (t<=1)
		mh_print( KBPOSX +1+43*4 +8, KBPOSY +2 + 37*3+23 +14, "space", CORSCHR );
}


//==============================================================
// EBhEwȋҔ
//--------------------------------------------------------------

static void getBack(void)
{
	BoxCopy( gBackBuf,KBPOSX,KBPOSY,194 +24,166 );
}


//==============================================================
// EBhEwi̕
//--------------------------------------------------------------

static void putBack(void)
{
	if (!gBDFlag)
		BoxPaste( gBackBuf,KBPOSX,KBPOSY );
}


//==============================================================
// ϊC̈ʒu
//--------------------------------------------------------------
// gCx,gCyŎw肳ĂJ[\ʒuɕϊCWJꍇ̎ۂ̍WƃTCYvZB
// ʒ[\tgL[ƂԂȂJnʒuCB
//--------------------------------------------------------------

static void InLinePos(char *str,int *x,int *wx)
{
	*wx = strlen(str) * FONTX;					// ̃hbg
	*x = *gCx;
	if (*x+*wx>480) *x = 480 - *wx;				// ʂ͂ݏoȂJnʒu炷
	if (*gCy+FONTY>KBPOSY && gMode==1)			// \tgL[ƏdȂȂJnʒu炷
		if (*x+*wx>KBPOSX) *x = KBPOSX - *wx;
}


//==============================================================
// ϊC̕\
//--------------------------------------------------------------
// blk ϊΏۂ̕
//--------------------------------------------------------------
// gCx,gCyŎw肳ĂJ[\ʒuɕϊC̕\sB
// \tgL[Ɋ|Ȃ悤Ɉʒu␳܂B
// blkŎw肳ꂽ擪̔wiFς܂B
//--------------------------------------------------------------

static void InLine(char *str,int blk)
{
	int	x,wx,wx1,wx2;

	InLinePos( str,&x,&wx );									// ϊCʒu
	if (wx){
		if (blk*FONTX >= wx){
			wx1 = wx;
			wx2 = 0;
		} else {
			wx1 = blk * FONTX;
			wx2 = wx - wx1;
		}
		if (wx1)
			BoxFill( x,*gCy,wx1,FONTY,CORCHCU,CORCHCU );		// wiiϊʁj
		if (wx2)
			BoxFill( x+wx1,*gCy,wx2,FONTY,CORCHBK,CORCHBK );	// wiiϊʁj
		mh_print( x,*gCy,str,CORCHCR );							// ϊC
	}
}


//==============================================================
// ϊC̔wȋҔ
//--------------------------------------------------------------

static void getInLine(char *str)
{
	int	x,wx;

	InLinePos( str,&x,&wx );					// ϊCʒu
	if (wx){
		BoxCopy( gInLnBuf,x,*gCy,wx,FONTY );
	}
}


//==============================================================
// ϊC̔wi̕
//--------------------------------------------------------------

static void putInLine(char *str)
{
	int	x,wx;

	if (!gBDFlag){
		InLinePos( str,&x,&wx );				// ϊCʒu
		if (wx){
			BoxPaste( gInLnBuf,x,*gCy );
		}
	}
}


//==============================================================
// ړ[h̏
//--------------------------------------------------------------

static void move(char *str)
{
	int		ch;

	ch = Sgetchar();
	if (ch==0x02){								//  i\tgL[[hցj
		ch = 0;
		gMode = 3;								// \tgL[[hJڏ
	} else {
		str[0] = ch;
		str[1] = 0;
	}
}


//==============================================================
// VtgJIS̑P`FbN
//--------------------------------------------------------------
// ߂l  0:Pł͂Ȃ
//        -1:Pł
//--------------------------------------------------------------

int chkSJIS(unsigned char cr)
{
	if (cr<0x80U || (cr>=0xA0U && cr<0xE0U) || cr>=0xFDU){
		return 0;
	} else {
		return -1;
	}
}


//==============================================================
// \tgL[[h̏
//--------------------------------------------------------------

static void keyboard(char *str)
{
	static SceCtrlData	pad1,pad2;
	static int getFlag = 0;
	int		i,p,s,ch,fp,pos;
	char	si[3];
	char	sdt[] = "ĂƂ͂ЂӂւكJLNPRTVXZ\\^`cegnqtwz",	// uJvt
			sht[] = "͂Ђӂւكnqtwz";																	// uKvt

	fp = 0;										// ʂɕύX
	si[2] = 0;

	sceCtrlReadBufferPositive( &pad1, 1 );
	switch (ch = Sgetchar()){					// J[\L[
	case 0x03:									// L
		break;
	case 0x04:									// R
		gKt++;
		if (gSt[0]==0){
			if (gKt>5) gKt = 0;
		} else {
			if (gKt>5) gKt = 0;
		}
		fp = 1;
		break;
	case 0x02:									// 
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gSt[0]==0){
				gMode = 0;
			} else {
				putInLine(gSt);					// ϊCU
				gMode = 2;						// ϊ
			}
		} else {
			si[0] = gKeyTable[gKt][(gKy*20+gKx*4+0) *2];
			si[1] = gKeyTable[gKt][(gKy*20+gKx*4+0) *2+1];
			fp = 2;
			gKfa = 1;
		}
		break;
	case 0x08:									// 
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gSt[0]!=0){
				putInLine(gSt);					// ϊCwi𕜌
				pos = strlen(gSt);
				pos--;
				p = 0;
				while (1){						// Sp␳
					s = 1 -chkSJIS(gSt[p]);
					if (p+s>pos) break;
					p += s;
				}
				gSt[p] = 0;
				if (s==2) gSt[p+1] = 0;
				getInLine(gSt);					// ϊCwi擾
			}
			fp = 1;
		} else {
			si[0] = gKeyTable[gKt][(gKy*20+gKx*4+1) *2];
			si[1] = gKeyTable[gKt][(gKy*20+gKx*4+1) *2+1];
			fp = 2;
			gKfa = 1;
		}
		break;
	case 0x0D:									// 
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gSt[0]==0){
				gMode = 0;
			} else {
				putInLine(gSt);					// ϊCwi𕜌
				for (i=0; i<CHLEN ;i++){
					str[i] = gSt[i];
					gSt[i] = 0;
				}
			}
		} else {
			si[0] = gKeyTable[gKt][(gKy*20+gKx*4+2) *2];
			si[1] = gKeyTable[gKt][(gKy*20+gKx*4+2) *2+1];
			fp = 2;
			gKfa = 1;
		}
		break;
	case 0x1B:									// ~
		if (pad1.Buttons & PSP_CTRL_LTRIGGER){
			if (gSt[0]==0){
				gMode = 0;
			} else {
				putInLine(gSt);					// ϊCwi𕜌
				for (i=0; i<CHLEN ;i++){
					gSt[i] = 0;
				}
			}
		} else {
			si[0] = gKeyTable[gKt][(gKy*20+gKx*4+3) *2];
			si[1] = gKeyTable[gKt][(gKy*20+gKx*4+3) *2+1];
			fp = 2;
			gKfa = 1;
		}
		break;
	case 0x1C:									// 
		gKx++;
		if (gKx>4) gKx = 0;
		fp = 1;
		break;
	case 0x1D:									// 
		gKx--;
		if (gKx<0) gKx = 4;
		fp = 1;
		break;
	case 0x1E:									// 
		gKy--;
		if (gKy<0) gKy = 3;
		fp = 1;
		break;
	case 0x1F:									// 
		gKy++;
		if (gKy>3) gKy = 0;
		fp = 1;
		break;
	}

	if (fp==2){																// ϊsɒǉ
		if (!chkSJIS(si[0])) si[1] = '\0';
		if (gSt[0]!=0){														// Qڈȍ~
			putInLine(gSt);													// ϊCwi𕜌
			pos = strlen(gSt) - 2;
			if (strcmp(si,"J")==0){
				if ((unsigned char)gSt[pos  ]==0x83 &&
				    (unsigned char)gSt[pos+1]==0x45){					//uEvuv
					gSt[pos+1] = 0x94;
					si[0] = 0;
					si[1] = 0;
				} else {
					for (i=0; i<40 ;i++)
						if (gSt[pos]==sdt[i*2] && gSt[pos+1]==sdt[i*2+1]) break;
					if (i!=40){												// uJv̕tȂO̕C
						gSt[pos+1]++;
						si[0] = 0;
						si[1] = 0;
					}
				}
			}else if (strcmp(si,"K")==0){
				for (i=0; i<10 ;i++)
					if (gSt[pos]==sht[i*2] && gSt[pos+1]==sht[i*2+1]) break;
				if (i!=10){													// uKv̕tȂO̕C
					gSt[pos+1] += 2;
					si[0] = 0;
					si[1] = 0;
				}
			}
		} else {															// P
			if (gKt>3){														// p̏ꍇ
				str[0] = si[0];												// ̂܂܏o
				str[1] = 0;
				si[0] = 0;
			}
		}
		if (gSt[CHLEN -2]==0){
			strcat( gSt,si );												// ǉ
			getInLine(gSt);													// ϊCwi̎擾
		}
	}

	pad2 = pad1;

	if (str[0]){								// o͂ꍇ̓EBhEꎞIɏ
		putBack();
		getFlag = 1;
	} else {
		if (getFlag){							// OEBhEĂȂwiĎ擾
			getBack();
			getFlag = 0;
		}
		if (gMode==1){							// [hɑJڂƂ͎sȂ
			InLine( gSt,0 );					// ϊC\
			DrawKey( gKx,gKy,gKt );				// \tgL[\
		} else {
			putBack();							// \tgL[
		}
	}
}


//==============================================================
// char񂩂SpR[h擾
//--------------------------------------------------------------

static unsigned int fcode(char *str)
{
	return ((unsigned char)str[0] * 0x100 + (unsigned char)str[1]);
}


//==============================================================
// char񂩂intf[^擾
//--------------------------------------------------------------

static unsigned int getInt(char *str)
{
	return ((unsigned char)str[0] + (unsigned char)str[1] * 0x100);
}


//==============================================================
// Spʂ̐؂蕪
//--------------------------------------------------------------

static int codeChk(char *str,unsigned int ar1,unsigned int ar2)
{
	unsigned int cr;
	int pos;

	pos = 0;
	while (pos<strlen(str)){
		if (chkSJIS(str[pos])){
			cr = fcode(&str[pos]);
			pos += 2;
		} else {								// p瑦I
			break;
		}
		if (cr<ar1 || cr>ar2)
			break;								// ͈͊O̕I
	}
	return pos;
}


//==============================================================
// ϊ
//--------------------------------------------------------------
// len      ϊΏۂƂȂ镶ߒioCgj
// adjust      0:ߒ͎wlɋŒ
//          ȊO:ߒ͎wlZύXꍇ
// count    P̐
// wordList PꃊXgichar wordList[50][33]̔zw肷邱Ɓj
//
// ߂l   Tsu݁v̒ioCgj
//--------------------------------------------------------------
// gSt̓ǂ݂Ɏ擾B
// wordList̍Ōɂ͒Tsߒ́u݁v̂̂ĂB
// Ɉv̂ꍇłŒłu݁v͕Ԃ܂B
//--------------------------------------------------------------

static int setkanji(int len,int adjust,int *count,char wordList[][33])
{
	unsigned int	cr;
	int		i,j,hp,sp,sp2,sp3,tmp,sjis;
	long	pos,pos2;

	*count = 0;
	cr = 0;
	gDicWordPos = -1;

	if (chkSJIS(gSt[0])){						// 擪SpȂ
		cr = fcode(&gSt[0]);					// 擪
		if (cr<0x8200U){						// LȂ
			hp = 0;
		} else if (cr<0x82F2U){					// Ђ炪ȂȂ
			hp = cr - 0x829FU +1;
		} else if (cr==0x8394U){				// uv
			hp = 84;
		} else {
			hp = -1;							// sȂ
		}
	} else {									// 擪pȂ
		hp = -2;
	}

	if (hp<0){											// sȂꍇiőΉĂȂ擪j
		if (adjust){
			if (hp==-2){								// p̕I
				for (sp=0; sp<strlen(gSt) ;sp++)
					if (chkSJIS(gSt[sp])) break;
			} else {									// ̑Sp^Cvɂ܂Ƃ߂
				if (cr<0x8259U){						// 
					sp = codeChk( gSt,0x824F,0x8258 );
				} else if (cr<0x829BU){					// At@xbg
					sp = codeChk( gSt,0x8260,0x829A );
				} else if (cr<0x8397U){					// J^Ji
					sp = codeChk( gSt,0x8340,0x8396 );
				} else if (cr<0x83D7U){					// MV
					sp = codeChk( gSt,0x839F,0x83D6 );
				} else if (cr<0x8492U){					// VA
					sp = codeChk( gSt,0x8440,0x8491 );
				} else {								// L
					sp = codeChk( gSt,0x84A0,0x879F );
				}
			}
		} else {
			sp = len;									// ^Cv͖
		}

	} else {												// ϊsꍇ
		pos = gHEDtbl[hp];									// ɑΉ鎫R[h̊Jnʒu
		if (pos==0xFFFFFFFF){								// ɓo^Ȃ
			sp = 2;
		} else {											// ɐ擪o^Ăꍇ
			pos += 2;
			sp2 = sp3 = 0;
			pos2 = -1;
			while(1){
				sp = 0;
				while (gDic[pos+sp]!=0){					// ݂ɑΉP茟
					if (gDic[pos+sp]!=gSt[sp]) break;
					sp++;
					if (sp==len) break;
				}
				if (gDic[pos+sp]==0){						// P┭iƒv̂邩Ȃ̂ŒT͏IȂj
					pos2 = pos;
					sp3 = sp;
				}
				if (hp==0){									// L̏ꍇ̏I
					if (fcode(&gDic[pos])>0x829E)
						break;
				} else {									// Ђ炪Ȃ̏ꍇ̏I
					if (sp<sp2)								// v镶OZȂTI
						break;
				}
				sp2 = sp;
				tmp = getInt(&gDic[pos-2]);					// ̒Pւ̑΋iintj
				if (tmp==0xFFFF) break;						// ITI
				pos += tmp;
			}

			if (pos2==-1){						// ɍڂĂȂiLϊ悤ƂꍇɋN肦j
				sp = 2;
			} else if (adjust==0 && sp3!=len){	// w肳ꂽߒɑȂ
				sp = len;
			} else {							// PꃊXg荞
				sp = sp3;
				pos = pos2 + strlen(&gDic[pos2]) +1;
				gDicWordPos = pos;				// ŎLڏւ邽߂
				*count = gDic[pos++];			// Pꐔibytej
				if (*count>49) *count = 49;		// Pꐔiobt@I[o[t[΍j
				for (i=0; i<*count ;i++){		// P荞
					tmp = strlen(&gDic[pos]);
					if (tmp>32) tmp = 32;		// P̒iobt@I[o[t[΍j
					sjis = 0;
					for (j=0; j<tmp ;j++){
						wordList[i][j] = gDic[pos+j];
						if (sjis){				// ɈꍇɃS~c鋰ꂪ̂
							sjis = 0;
						} else {
							sjis = chkSJIS(gDic[pos+j]);
						}
					}
					wordList[i][j+sjis] = '\0';
					pos += strlen(&gDic[pos])+1;
				}
			}
		}
	}

	for (i=0; i<sp ;i++)						// ɖꍇ́u݁v̂̂PꃊXgɒǉ
		wordList[*count][i] = gSt[i];
	wordList[*count][i] = '\0';
	(*count)++;

	return sp;
}


//==============================================================
// ⃊Xg̈ʒu
//--------------------------------------------------------------
// ϊC̉Ɋ⃊Xg̈ʒuݒ肷B
// ʒ[ƂԂȂɐݒ肵܂B
//--------------------------------------------------------------

static void kListPos(int *x,int *y,int *wx,int *wy,char wordList[][33],int count)
{
	int i,len,max;

	max = 0;
	for (i=0; i<count ;i++){
		len = strlen(wordList[i]);
		if (len>max) max = len;
	}
	*wx = 2+ max * FONTX +3 +4 +1;
	if (count>KLIST){
		*wy = KLIST * (FONTY+1)+2 -1;
	} else {
		*wy = count * (FONTY+1)+2 -1;
	}
	
	*x = *gCx;
	if (*x+*wx>480) *x = 480 - *wx;				// ʂ͂ݏoȂJnʒu炷
	*y = *gCy + FONTY+1;
	if (*y+*wy>272) *y = *gCy -1 - *wy;
}

//==============================================================
// ⃊Xg̕\
//--------------------------------------------------------------
// gCx,gCyŎw肳ĂJ[\ʒủɊ⃊Xg̕\sB
//--------------------------------------------------------------

static void kList(char wordList[][33],int count,int index)
{
	int	i,page,len,pos,n,x,y,wx,wy;

	kListPos( &x, &y, &wx, &wy, wordList, count );		// ⃊Xgʒu
	BoxFill( x, y, wx, wy, CORFL1, CORIN );

	VLine( x + wx-1-4-1, y, wy, CORFL1 );
	page = index / KLIST;
	if (count<KLIST){
		pos = 0;
		len = wy -2;
	} else {
		pos = page * (wy-2) * KLIST / count;
		len = (wy-1) * KLIST / count;
	}
	if (len>wy-2) len = wy -2;							// XN[o[̃TCY␳
	if (pos+len>wy-2) pos = wy-2 -len;					// XN[o[̈ʒu␳
	for (i=0; i<4 ;i++)									// XN[o[
		VLine( x + wx-2-i, y+1 +pos, len, CORRBAR );

	pos = index % KLIST;
	y += 1;
	x += 1;
	BoxFill( x, y +pos *(FONTY+1), wx-2-4-1, FONTY, CORCUR, CORCUR );
	n = page * KLIST;
	for (i=0; i<KLIST ;i++){
		if (n>=count) break;
		mh_print( x+2,y,wordList[n],CORWCHR );			// ϊC
		y += FONTY +1;
		n++;
	}
}


//==============================================================
// ⃊Xg̔wȋҔ
//--------------------------------------------------------------

static void getkList(char wordList[][33],int count)
{
	int	x,y,wx,wy;

	kListPos( &x, &y, &wx, &wy, wordList, count );		// ⃊Xgʒu
	BoxCopy( gkListBuf,x,y,wx,wy );
}


//==============================================================
// ⃊Xg̔wi̕
//--------------------------------------------------------------

static void putkList(char wordList[][33],int count)
{
	int	x,y,wx,wy;

	if (!gBDFlag){
		kListPos( &x, &y, &wx, &wy, wordList, count );	// ⃊Xgʒu
		BoxPaste( gkListBuf,x,y );
	}
}


//==============================================================
// Lڏ̓ւ
//--------------------------------------------------------------

static void dicWordEx(int index)
{
	long	pos,pos2;
	char	str[65];
	int		i,n,len;

	if (gDicWordPos==-1) return;				// ʒuw肳ĂȂ
	if (gDic[gDicWordPos]<(index+1)) return;	// o^ꐔȏw肵Ă
	if (!index) return;							// ɐ擪ʒuɂ

	gSaveFlag = -1;

	pos = gDicWordPos +1;
	pos2 = pos;
	n = 0;
	while (n<index){							// ڕẄʒuT
		pos += strlen(&gDic[pos]) +1;
		n++;
	}
	strcpy(str,&gDic[pos]);						// 擪ɈړҔ
	len = strlen(&gDic[pos]) +1;				// ړTCY
	n = pos - pos2;
	pos--;
	for (i=n; i>0 ;i--){						// ̑̌ړ
		gDic[pos+len] = gDic[pos];
		pos--;
	}
	strcpy(&gDic[pos2],str);					// ڕW擪ɏ߂
}


//==============================================================
// I[h
//--------------------------------------------------------------

static void change(char *str)
{
	static char	wordList[50][33],ILstr[64];
	static int	mode = 0,count,len,index,getFlag = 0;
	int	l,p,s,ch,df;

	if (!mode){									// ϊJn̏ݒ
		len = setkanji( strlen(gSt),1,&count,wordList );
		index = 0;
		mode = 1;
		strcpy( ILstr,wordList[index] );		// ϊΏ
		strcat( ILstr,&gSt[len] );				// ϊΏ
		getInLine(ILstr);						// Ԃ̕ϊCwi擾
		getkList( wordList,count );
	}

	df = 0;

	ch = Sgetchar();
	switch (mode){
	case 1:										// I[h
		switch (ch){
		case 0x03:								// L
			break;
		case 0x04:								// R
			break;
		case 0x0D:								// 
			putInLine(ILstr);					// ϊC
			putkList( wordList,count );			// ⃊Xg
			strcpy( str,wordList[index] );
			strcpy( gSt,&gSt[len] );
			if (strlen(gSt)==0){				// u݁vSĖȂ\tgL[[h
				gMode = 3;
			}
			if ((count-1)!=index)				// ⃊Xg̍Ō̌́u݁vȂ̂œւ͍sȂ
				dicWordEx(index);
			mode = 0;
			break;
		case 0x08:								// 
		case 0x1B:								// ~
			putInLine(ILstr);					// ϊC
			putkList( wordList,count );			// ⃊Xg
			mode = 0;
			gMode = 3;
			break;
		case 0x1C:								// 
			putInLine(ILstr);					// ϊC
			putkList( wordList,count );			// ⃊Xg
			len += 1 -chkSJIS(gSt[len]);		// Sp␳
			l = strlen(gSt);
			if (len>l) len = l;
			strcpy( ILstr,gSt );
			getInLine(ILstr);
			getkList( wordList,count );
			mode = 2;
			break;
		case 0x1D:								// 
			putInLine(ILstr);					// ϊC
			putkList( wordList,count );			// ⃊Xg
			len--;
			if (len<1) len = 1;
			p = 0;
			while (1){							// Sp␳
				s = 1 -chkSJIS(gSt[p]);
				if (p+s>len) break;
				p += s;
			}
			if (p==0) p = 2;
			len = p;
			strcpy( ILstr,gSt );
			getInLine(ILstr);
			getkList( wordList,count );
			mode = 2;
			break;
		case 0x1E:								// 
			putInLine(ILstr);					// ϊC
			putkList( wordList,count );			// ⃊Xg
			index--;
			if (index<0) index = count -1;
			df = 1;
			break;
		case 0x1F:								// 
		case 0x02:								// 
			putInLine(ILstr);					// ϊC
			putkList( wordList,count );			// ⃊Xg
			index++;
			if (index>count-1) index = 0;
			df = 1;
			break;
		}
		break;
	
	case 2:										// ߒI[h
		switch (ch){
		case 0x03:								// L
			break;
		case 0x04:								// R
			break;
		case 0x0D:								// 
			strncpy( str,gSt,len );
			str[len] = '\0';
			strcpy( gSt,&gSt[len] );
			if (strlen(gSt)==0){				// u݁vSĖȂ\tgL[[h
				putInLine(ILstr);				// ϊC
				gMode = 3;
			}
			mode = 0;
			break;
		case 0x08:								// 
		case 0x1B:								// ~
			putInLine(ILstr);					// ϊC
			mode = 0;
			gMode = 3;
			break;
		case 0x1C:								// 
			len += 1 -chkSJIS(gSt[len]);		// Sp␳
			l = strlen(gSt);
			if (len>l) len = l;
			break;
		case 0x1D:								// 
			len--;
			if (len<1) len = 1;
			p = 0;
			while (1){							// Sp␳
				s = 1 -chkSJIS(gSt[p]);
				if (p+s>len) break;
				p += s;
			}
			if (p==0) p = 2;
			len = p;
			break;
		case 0x1E:								// 
			len = setkanji( len,0,&count,wordList );
			index = count -1;
			mode = 1;
			df = 1;
			break;
		case 0x1F:								// 
		case 0x02:								// 
			len = setkanji( len,0,&count,wordList );
			index = 0;
			mode = 1;
			df = 1;
			break;
		}
		break;
	}

	if (df){									// ϊɕω
		putInLine(ILstr);						// ϊC
		strcpy( ILstr,wordList[index] );		// ϊΏ
		strcat( ILstr,&gSt[len] );				// ϊΏ
		getInLine(ILstr);
		getkList( wordList,count );
	}

	if (str[0]){								// o͂ꍇ̓EBhEꎞIɏ
		putInLine(ILstr);						// ϊC
		putkList( wordList,count );				// ⃊Xg
		getFlag = 1;
	} else {
		if (getFlag){							// OEBhEĂȂwiĎ擾
			getInLine(ILstr);
			getkList( wordList,count );
			getFlag = 0;
		}
		if (gMode==2){							// \tgL[[hɑJڂƂ͎sȂ
			switch (mode){						// ϊC\
			case 1:
				InLine( ILstr,strlen(wordList[index]) );
				kList( wordList,count,index );
				break;
			case 2:
				InLine(ILstr,len);
				break;
			}
		}
	}
}


//==============================================================
// 
//--------------------------------------------------------------
// *str   ͂ꂽiő33oCg asciizj
// ߂l str̂
//--------------------------------------------------------------
// \tgL[{[hɂ镶̓́B
// ȉpIMEɂ銿ϊsB
// łȂJ[\L[̊e{^Rg[R[hƂĕԂB
// ͕́im肳ꂽꍇ́jstrɓĂ܂B
//--------------------------------------------------------------

char *Sgets(char *str)
{
	int i;

	for (i=0; i<CHLEN ;i++)
		str[i] = 0;

	switch (gMode){
	case 0:										// ړ[h
		move(str);
		break;

	case 1:										// L[{[h[h
		keyboard(str);
		break;

	case 2:										// I[h
		change(str);
		break;

	case 3:										// \tgL[[hɑJڂ鏀
		gMode = 1;
		getInLine(gSt);
		getBack();
		keyboard(str);
		break;

	}
	return str;
}




